{ Code by VanDamM / [WRC] }
{F+}
Unit P_Sharp;
Interface
Uses V_Sharp, Mpalette;
Type
 Pcx_Header = Record
      manufacturer : byte; { ⥫ }
      version: byte;       {  Paintbrash }
      encoding: byte;      { ஢ }
      bits_per_pixel: byte;  { -   ᥫ }
      MinX,MinY: integer;    { ࠧ ࠦ,  孨 㣮 }
      MaxX,MaxY: integer;    { ࠧ ࠦ, ࠢ  㣮 }
      horz_res: integer;     { - ᥫ  ਧ⠫ }
      vert_res: integer;     { - ᥫ  ⨪ }
      ega_palette: array[0..47] of byte; {  }
      reserved: byte;                    {  }
      num_color_planes: byte;            {  }
      bytes_per_line: integer;           {  }
      palette_type: integer;             {  }
      padding: array[1..62] of byte;     {  }
 End;

  FName = string[12];


Procedure ReadPCXfile(WhereDraw: DBufferPtr; Name: FName; UX, UY : integer );

Implementation

Procedure ReadPCXfile(WhereDraw: DBufferPtr; Name: FName; UX, UY : integer );
Var
    X, Y, i, k: Integer;
    Pcx_Head : Pcx_Header;
    Pcx_File : file;
    Data: byte;

Begin
{ 뢠 䠩 ଠ PCX }
 Assign(Pcx_File, Name);
 Reset(Pcx_File, 1);

{ ⥭  }
Seek(Pcx_File, FileSize(Pcx_File)-768);
for x:=0 to 255 do
 begin
 BlockRead(Pcx_File, PaletteUsr[x].R, 1);
  PaletteUsr[x].R:=PaletteUsr[x].R shr 2;
 BlockRead(Pcx_File, PaletteUsr[x].G, 1);
  PaletteUsr[x].G:=PaletteUsr[x].G shr 2;
 BlockRead(Pcx_File, PaletteUsr[x].B, 1);
  PaletteUsr[x].B:=PaletteUsr[x].B shr 2;
 end;

{ ⠭  }
 for y:=20 to 255 do
    begin
     port[$3C6]:= $FF;
     port[$3C8]:= y;
     port[$3C9]:= PaletteUsr[y].R;
     port[$3C9]:= PaletteUsr[y].G;
     port[$3C9]:= PaletteUsr[y].B;
    end;

{ ⥭  PCX 䠩 }
  Seek(Pcx_File, 0);
  BlockRead(Pcx_File, Pcx_Head, 128);

{ ⥭ ஢ ࠦ }
For Y:=UY to (UY+Pcx_Head.vert_res-1) do
 For X:=UX to (UX+Pcx_Head.horz_res-1) do
  begin
   BlockRead(Pcx_File, Data, 1);
   If Data>=192 then
    begin
     i:=Data-192; BlockRead(Pcx_File, Data, 1);
     For k:=1 to i do
      begin
        If X>(UX+Pcx_Head.horz_res) then begin X:=UX; Y:=Y+1; end;
        PutPixel(WhereDraw, X,Y,Data);
        If k<i then Inc(X);
      end
    end
   else
    PutPixel(WhereDraw, X,Y,Data);
  end;
{  }
Close(Pcx_File);
End;
End.